<?php


/**
* class to handle templates
* methods: get(string templatename), out(string templatename)
*
* usage:
* $tpl = new tpl();
*
* // parse template 'templatename' into $handle1
* eval("\$handle1 = \"".$tpl->get("templatename")."\";");
*
* // parse and directly print out template 'templatename'
* eval("\$tpl->out(\"".$tpl->get("templatename")."\");"); 
*
*/
class tpl
{
	/**
	* @var string templatedirectory
	* @access private
	*/
	var $dir;
	
	/**
	* @var string fileextension for templates
	* @access private
	*/
	var $ext;
	
	/**
	* @var array templatecache
	* @access private
	*/
	var $cache=array();
	
	
	
	/**
	* constructor of this class
	* 
	* @param string dir templatedirectory
	* @param string ext fileextension for templates
	*/
	function tpl($dir="templates",$ext="tpl")
	{
		$this->dir=$dir;
		$this->ext=$ext;
	
	}
	
	
	
	/**
	* returns the content of the template specified in tpl
	*
	* @param string tpl
	* @return string template
	* @access public
	*/
	function get($tpl) {
		return str_replace("\"","\\\"",implode("",file($this->dir."/".$tpl.".".$this->ext)));
	}
	
	
	
	
	/**
	* print out the template specified in tpl
	*
	* @param string tpl
	* @return void
	* @access public
	*/
	function out($tpl)
	{
		echo $tpl;
	}
}
?>