<?php
require("global.php");
eval("\$tpls['header'] = \"".$tpl->get("header")."\";");
eval("\$tpls['footer'] = \"".$tpl->get("footer")."\";");

// set a time limit because archive operations may last longer than normal operations
@set_time_limit(0);

// initiate parameters
if(isset($_REQUEST['newdir'])) $newdir = trim($_REQUEST['newdir']);
else $newdir = "";
if(isset($_REQUEST['type'])) $type = $_REQUEST['type'];
else $type = "";
if(isset($_REQUEST['send'])) $send = $_REQUEST['send'];
else $send = "";
if(isset($_REQUEST['dir'])) $dir = $_REQUEST['dir'];
else $dir = "";
if(isset($_REQUEST['comment'])) $comment = $_REQUEST['comment'];
else $comment = "";
if(isset($_REQUEST['log'])) $log = $_REQUEST['log'];
else $log = "";
if(isset($_REQUEST['archive_id'])) $archive_id = intval($_REQUEST['archive_id']);
else $archive_id=0;


if($archive_id)
{
	$archive_info = $db->query_first("SELECT * FROM ".$db->getPrefix()."archives WHERE archive_id='".$archive_id."'");
	if(!$archive_info['archive_id'])
	{
		show_error("input_error");
	}
	else
	{
		$project_id=$archive_info['project_id'];
		$dir=$archive_info['dir'];
		$log=$archive_info['log'];
	}
}
if($project_id)
{
	if(!isset($project_info)) $project_info = $db->query_first("SELECT * FROM ".$db->getPrefix()."projects WHERE project_id=$project_id", MYSQL_ASSOC);
	// user has no writeaccess
	if(!$writeaccess[$project_id])
	{
		show_error("access_denied");
	}
}

// input_error: no project given
elseif(!$project_id)
{
	show_error("input_error");
}







// add new folder
if($type=="dir")
{
	// all required information given?
	if($send=="send" && $project_id && $newdir)
	{
		// invalid dirname
		if(stristr($newdir,"/") || stristr($newdir,"\\") || stristr($newdir,"<") || stristr($newdir,">") || stristr($newdir,":") || stristr($newdir,"*") || stristr($newdir,"?") || stristr($newdir,"\"") || stristr($newdir,"|")) show_error("input_error");

		// lock project (read and write)
		lock_project($project_id);

		// check if directory already exists
		$olddir = $db->query_first("SELECT * FROM ".$db->getPrefix()."files WHERE project_id='$project_id' AND dir='".($dir."/".$newdir)."' AND isfile='0'");

		// directory does not exist, so create it
		if(!$olddir['file_id'])
		{
			$createdate = time();
			$db->query("INSERT INTO ".$db->getPrefix()."files (project_id,dir,createdate,isfile) VALUES('$project_id','".addslashes(($dir."/".$newdir))."','$createdate','0')");
			$db->query("UPDATE ".$db->getPrefix()."projects SET lasteditor='$user_info[user_id]', lastchange='$createdate' WHERE project_id='$project_id'");
		}
		// directory did exist, but may be deleted.
		elseif($olddir['file_id'] && $olddir['deletedate'])
		{
			$db->query("UPDATE ".$db->getPrefix()."files SET deletedate='0' WHERE file_id='$olddir[file_id]'");
		}
		
		// unlock the project
		unlock_project($project_id);

		// send email notifications
		notify($project_id,$user_info['user_id'],$user_info['displayname'],$user_info['email'],time(),"newfolder",array("$dir/$newdir"));

		// print "done message"
		//eval("\$tpl->out(\"".$tpl->get("done")."\");");
		show_msg("done");
	}
	else // not all required information given => input error
	{
		show_error("input_error");
	}
}







// file upload
elseif($type=="file")
{

	// all required information given ?
	if($send=="send" && $project_id && $type=="file" && $log && $_FILES['newfile']['name'])
	{
		// initiate upload class
		include("class.upload.php");
		$upload = new upload();
		$upload->setUploadDir("./files");
		$file = "newfile";
		$filename = $upload->extract_filename($file);
		$extension = $upload->extract_extension($file);

		// invalid filename
		if(stristr($filename,"/") || stristr($filename,"\\") || stristr($filename,"<") || stristr($filename,">") || stristr($filename,":") || stristr($filename,"*") || stristr($filename,"?") || stristr($filename,"\"") || stristr($filename,"|")) show_error("input_error");

		// lock project (read and write)
		lock_project($project_id);
		$createdate = time();

		// add file to project
		list($version_id,$file_id) = addfile($project_id,$filename,$extension,$dir,$comment,$log,$createdate);

		// upload file
		$done = $upload->doUpload($file,($version_id.ifelse($extension,".".$extension)));
		@chmod("./files/".$version_id.ifelse($extension,".".$extension),0777);
		
		// get checksum of the file and of the last version
		$checksum=getchecksum($version_id);
		$db->query("UPDATE ".$db->getPrefix()."versions SET checksum='".$checksum."', size='".$_FILES['newfile']['size']."' WHERE version_id='$version_id'");
		$r_preversion = $db->query_first("SELECT * FROM ".$db->getPrefix()."versions WHERE project_id='$project_id' AND file_id='$file_id' AND version_id<>'$version_id' AND deletedate='0' AND createdate<='$createdate' ORDER BY createdate DESC LIMIT 1",MYSQL_ASSOC);
		
		// compare checksum with the checksum of the last version
		// if the checksums equal, stop the update and rollback
		if($r_preversion['version_id'] && $r_preversion['checksum']==$checksum)
		{
			@unlink("./files/".$version_id.ifelse($extension,".".$extension));
			$db->query("DELETE FROM ".$db->getPrefix()."versions WHERE version_id='$version_id'");
			$db->query("UPDATE ".$db->getPrefix()."files SET version_id='$r_preversion[version_id]' WHERE file_id='$file_id'");
		}
		
		// checksums do not equal, continue normally
		else
		{
			// update date of lastchange etc. etc.
			update_project($project_id,$user_info['user_id'],$createdate);
			
			// send email notifications
			notify($project_id,$user_info['user_id'],$user_info['displayname'],$user_info['email'],time(),"newfile",array("$dir/".get_shownfilename($filename,$extension)), $log);
		}
		
		// unlock the project
		unlock_project($project_id);
		
		// print "done message"
		//eval("\$tpl->out(\"".$tpl->get("done")."\");");
		show_msg("done");
	}
	// not all required information given => input_error
	else
	{
		show_error("input_error");
	}
}
















// upload an archive (Zip Archive or (gzipped) Tarball)
// archives are uploaded/extracted in several steps to avoid a timeout
elseif($type=="archive")
{
	// all required information given?
	if($send=="send" && $project_id && $log && $_FILES['archive']['tmp_name'])
	{
		// lock project
		lock_project($project_id);
		
		// initiate upload class and upload zipfile to a temp. file */
		include("class.upload.php");
		$upload = new upload();
		$upload->setUploadDir("./temp");
		$tmpname = uniqid("archive_");
		
		
		
		// check uploaded archive
		// only the following extensions are allowed: .tar.gz ; .tar ; .zip
		// mime type is checked as well (optional)
		$checkmime = false;
		$extension = get_fileextension($_FILES['archive']['name']);
		if($checkmime)
		{
			if($extension=="zip" && $_FILES['archive']['type']=="application/x-zip-compressed") $archive_type="zip";
			elseif($extension=="tar" && $_FILES['archive']['type']=="application/octet-stream") $archive_type="tgz";
			elseif(substr(basename($_FILES['archive']['name']),-6)=="tar.gz" && $_FILES['archive']['type']=="application/x-gzip-compressed")
			{
				$archive_type="tgz";
				$extension="tar.gz";
			}
			// uploaded archive is not allowed
			else show_error("input_error");
		}
		else
		{
			if($extension=="zip") $archive_type="zip";
			elseif($extension=="tar") $archive_type="tgz";
			elseif(substr(basename($_FILES['archive']['name']),-6)=="tar.gz")
			{
				$archive_type="tgz";
				$extension="tar.gz";
			}
			// uploaded archive is not allowed
			else show_error("input_error");
		}
		$upload->doUpload("archive",($tmpname.".".$extension));

		// insert archive information into database
		$archivefilename = "./temp/$tmpname.$extension";
		$db->query("INSERT INTO ".$db->getPrefix()."archives (filename,project_id,archive_type,dir,log) VALUES ('".$archivefilename."', '".$project_id."', '".$archive_type."', '".$dir."','".addslashes($log)."')");
		$archive_id=$db->insert_id();

		
		// if archive is a zip archive, read in the contentlist and insert all items into database table 'archiveitems'
		if($archive_type=="zip")
		{
			// initiate zip class
			include("class.zip.php");
			$zip = new readzip($archivefilename);
			$insertstr="";
	
			// go through the contentlist of the archive and build a sql-query to insert the data
			for($i=0;$i<count($zip->contentlist);$i++)
			{
				// check if filename is invalid
				$item_filename = get_filename(basename($zip->contentlist[$i]['filename']));
				$item_dirname = dirname($zip->contentlist[$i]['filename']);
				if(stristr($item_filename,"/") || stristr($item_filename,"\\") || stristr($item_filename,"<") || stristr($item_filename,">") || stristr($item_filename,":") || stristr($item_filename,"*") || stristr($item_filename,"?") || stristr($item_filename,"\"") || stristr($item_filename,"|")) show_error("input_error");
				if(stristr($item_dirname,"<") || stristr($item_dirname,">") || stristr($item_dirname,":") || stristr($item_dirname,"*") || stristr($item_dirname,"?") || stristr($item_dirname,"\"") || stristr($item_dirname,"|")) show_error("input_error");
				$insertstr.=",('".$archive_id."', '".$i."','".$zip->contentlist[$i]['filename']."','".$zip->contentlist[$i]['type']."','".$zip->contentlist[$i]['size']."','".$zip->contentlist[$i]['compressed_size']."')";
			}

			// insert the contentlist of the archive into the database
			$db->query("INSERT INTO ".$db->getPrefix()."archiveitems (archive_id,fileindex,filename,type,size,compressed_size) VALUES ".substr($insertstr,1));

			// unlock project and redirect to the next step: write temporary files
			unlock_project($project_id);
			header("Location: update.php?type=archive_writetmp&archive_id=$archive_id&sid=$sidviaget");
			exit;
		}
		
		// if archive is an (gzipped) tarball, redirect to the next step: uncompress tarball and insert contentlist into database
		elseif($archive_type=="tgz")
		{
			unlock_project($project_id);
			header("Location: update.php?type=tgz_uncompress&archive_id=$archive_id&sid=$sidviaget");
			exit;
		}
	}
	
	// not all required information given => input error
	else show_error("input_error");
}






// extract/add archive
// step: uncompress (gzipped) tarball 
// and insert contentlist of the archive to the databse
elseif($type=="tgz_uncompress")
{
	// lock project
	lock_project($project_id);
	
	
	// check if the uploaded archive must be uncompressed
	if(get_fileextension($archive_info['filename'])=="gz")
	{
		// if we use gzip via exec(), just call it to uncompress the tarball
		if($options['zipmode']=="phpexec")
		{
			exec("gzip -d ".$archive_info['filename']);
			$archive_info['filename']=substr($archive_info['filename'],0,strlen($archive_info['filename'])-3);
		}
		
		// we must use the zlib functions of php to uncompress the tarball
		elseif($options['zipmode']=="phpzlib")
		{
			$gzfh=gzopen($archive_info['filename'],"rb");
			$fh=fopen(substr($archive_info['filename'],0,strlen($archive_info['filename'])-3),"wb");
			while(!gzeof($gzfh))
			{
				$read_size = 100000;
				fwrite($fh,gzread($gzfh, $read_size),$read_size);
			}
			fclose($fh);
			gzclose($gzfh);
			@unlink($archive_info['filename']);
			$archive_info['filename']=substr($archive_info['filename'],0,strlen($archive_info['filename'])-3);
			@chmod($archive_info['filename'], 0777);
		}
		
		// save new temporary filename of the archive
		$db->query("UPDATE ".$db->getPrefix()."archives SET filename='".$archive_info['filename']."' WHERE archive_id='".$archive_id."'");
	}
	
	// now read the contentlist of the archive and insert it into the database
	include("class.tar.php");
	$tar = new readtar($archive_info['filename']);
	$insertstr="";
	// go throught the contentlist of the archive and build a sql-query
	for($i=0;$i<count($tar->contentlist);$i++)
	{
		// check if filename is invalid
		$item_filename = get_filename(basename($tar->contentlist[$i]['filename']));
		$item_dirname = dirname($tar->contentlist[$i]['filename']);
		if(stristr($item_filename,"/") || stristr($item_filename,"\\") || stristr($item_filename,"<") || stristr($item_filename,">") || stristr($item_filename,":") || stristr($item_filename,"*") || stristr($item_filename,"?") || stristr($item_filename,"\"") || stristr($item_filename,"|")) show_error("input_error");
		if(stristr($item_dirname,"<") || stristr($item_dirname,">") || stristr($item_dirname,":") || stristr($item_dirname,"*") || stristr($item_dirname,"?") || stristr($item_dirname,"\"") || stristr($item_dirname,"|")) show_error("input_error");
		$insertstr.=",('".$archive_id."', '".$i."','".$tar->contentlist[$i]['filename']."','".$tar->contentlist[$i]['type']."','".$tar->contentlist[$i]['size']."','".(0)."')";
	}
	
	// insert data into database
	$db->query("INSERT INTO ".$db->getPrefix()."archiveitems (archive_id,fileindex,filename,type,size,compressed_size) VALUES ".substr($insertstr,1));
	unset($tar);
	unset($insertstr);
	
	// unlock the project and redirect to the next step: write temp. files
	unlock_project($project_id);
	header("Location: update.php?type=archive_writetmp&archive_id=$archive_id&sid=$sidviaget");
	exit;
}




// upload/extract an archive
// step: extract the content of the archive into temporary files
// if the archive is a zip, these files may be gzip-compressed files
// this work is done in several steps to avoid a timeout
elseif($type=="archive_writetmp")
{
	// lock project
	lock_project($project_id);


	// archive: zip archive
	if($archive_info['archive_type']=="zip")
	{
		include("class.zip.php");
		$zip = new readzip($archive_info['filename']);
		
		// select items to extract in this loop
		$perpage=10;
		$result = $db->query("SELECT * FROM ".$db->getPrefix()."archiveitems WHERE archive_id='$archive_id' AND type='file' AND tmpfile='' ORDER BY fileindex ASC LIMIT $perpage");
		$archiveitemids="";
		$replacestring="";
		if($db->num_rows($result)>0)
		{
			while($row=$db->fetch_array($result,MYSQL_ASSOC))
			{
				// write the temporary file
				$tmpfile=$zip->writetmpfile($row['fileindex']);
				@chmod($tmpfile,0777);
				if(substr($tmpfile,-3)==".gz" && $row['size']==$row['compressed_size']) $row['compressed_size']++;
				$replacestring .= ",('".$row['archiveitem_id']."', '".$row['archive_id']."', '".$row['fileindex']."', '".addslashes($row['filename'])."', '".addslashes($tmpfile)."', '".$row['type']."', '".$row['size']."', '".$row['compressed_size']."')";
			}
			// mark done items and redirect to the next loop
			if($replacestring) $db->query("REPLACE INTO ".$db->getPrefix()."archiveitems (archiveitem_id, archive_id, fileindex, filename, tmpfile, type, size, compressed_size) VALUES".substr($replacestring,1));
			unlock_project($project_id);
			header("Location: update.php?type=archive_writetmp&archive_id=$archive_id&sid=$sidviaget");
			exit;
		}
		
		// all items done, redirect to the next step: uncompress the temporary files
		unlock_project($project_id);
		header("Location: update.php?type=zip_unzip&archive_id=$archive_id&sid=$sidviaget");
		exit;
	}
	
	
	
	// archive: (gzipped) tarball
	elseif($archive_info['archive_type']=="tgz")
	{
		include("class.tar.php");
		$tar = new readtar($archive_info['filename']);
		
		// select items to extract in this loop
		$perpage=10;
		$result = $db->query("SELECT * FROM ".$db->getPrefix()."archiveitems WHERE archive_id='$archive_id' AND type='file' AND tmpfile='' ORDER BY fileindex ASC LIMIT $perpage");
		$archiveitemids="";
		$replacestring="";
		if($db->num_rows($result)>0)
		{
			while($row=$db->fetch_array($result,MYSQL_ASSOC))
			{
				// extract the current item to a temporary file
				$tmpfile="./temp/uncompress_".$row['fileindex']."_".md5(uniqid(rand()));
				while(file_exists($tmpfile)) $tmpfile="./temp/uncompress_".$row['fileindex']."_".md5(uniqid(rand()));
				$tar->extract($row['fileindex'],$tmpfile);
				@chmod($tmpfile,0777);
				$replacestring .= ",('".$row['archiveitem_id']."', '".$row['archive_id']."', '".$row['fileindex']."', '".addslashes($row['filename'])."', '".addslashes($tmpfile)."', '".$row['type']."', '".$row['size']."', '".(0)."')";
			}
			// mark done items and redirect to the next loop
			if($replacestring) $db->query("REPLACE INTO ".$db->getPrefix()."archiveitems (archiveitem_id, archive_id, fileindex, filename, tmpfile, type, size, compressed_size) VALUES".substr($replacestring,1));
			unlock_project($project_id);
			header("Location: update.php?type=archive_writetmp&archive_id=$archive_id&sid=$sidviaget");
			exit;
		}
		
		// all items done
		// redirect to the next step: add the items to the project
		unlock_project($project_id);
		header("Location: update.php?type=archive_addfiles&archive_id=$archive_id&sid=$sidviaget");
		exit;
	}
}






// upload/extract archive
// step: uncompress items of an zip archive
// if the archive is a compressed zip archive, 
// the temporary files are gzip-compressed files 
// we must uncompress
elseif($type=="zip_unzip")
{
	// lock the project
	lock_project($project_id);
	
	
	// we can use gzip via exec(), simply extract all .gz files in the temporary directory
	if($options['zipmode']=="phpexec")
	{
		if($config['basedir']==".")
		{
			if(isset($_SERVER['PATH_TRANSLATED']))
			{
				$basedir = dirname($_SERVER['PATH_TRANSLATED']);
				chdir($basedir);
			}
		}
		exec("gzip -d -r ".$config['basedir']."/temp");
		$db->query("UPDATE ".$db->getPrefix()."archiveitems SET tmpfile=SUBSTRING(tmpfile,1,LENGTH(tmpfile)-3) WHERE archive_id='".$archive_id."' AND type='file' AND size<>compressed_size");
		unlock_project($project_id);
	}
	
	// we must use the zlib functions of php to extract the gzip files
	// to avoid a timeout, we do this in several steps
	elseif($options['zipmode']=="phpzlib")
	{
		include("class.zip.php");
		$zip = new readzip($archive_info['filename']);

		// select temp. files to uncompress in this loop
		$perpage="10";
		$result=$db->query("SELECT * FROM ".$db->getPrefix()."archiveitems WHERE archive_id='".$archive_id."' AND size<>compressed_size AND type='file' AND SUBSTRING(tmpfile,LENGTH(tmpfile)-1)='gz' LIMIT $perpage");
		$archiveitemids="";
		if($db->num_rows($result)>0)
		{
			while($row=$db->fetch_array($result,MYSQL_ASSOC))
			{
				// uncompress temporary file
				$archiveitemids.=",'".$row['archiveitem_id']."'";
				$zip->unziptmp($row['fileindex'],$row['tmpfile'],substr($row['tmpfile'],0,strlen($row['tmpfile'])-3));
				@chmod(substr($row['tmpfile'],0,strlen($row['tmpfile'])-3),0777);
				@unlink($row['tmpfile']);
			}
			// mark done files and redirect to the next loop
			$db->query("UPDATE ".$db->getPrefix()."archiveitems SET tmpfile=SUBSTRING(tmpfile,1,LENGTH(tmpfile)-3) WHERE archive_id='".$archive_id."' AND archiveitem_id IN (".substr($archiveitemids,1).")");
			unlock_project($project_id);
			header("Location: update.php?type=zip_unzip&archive_id=$archive_id&sid=$sidviaget");
			exit;
		}
	}
	
	// all temp. files uncompressed
	// redirect to the next (and last) step: add files to the project
	unlock_project($project_id);
	header("Location: update.php?type=archive_addfiles&archive_id=$archive_id&sid=$sidviaget");
	exit;
}







// upload/extract archive
// last step: add files to project
// and delete temporary files
// this is done in several steps to avoid a timeout
elseif($type=="archive_addfiles")
{
	// lock project
	lock_project($project_id);
	
	$createdate=time();
	$notify_updates = array();
	$files = array();

	// select files to add in this loop
	$perpage=10;
	$result = $db->query("SELECT * FROM ".$db->getPrefix()."archiveitems WHERE archive_id='".$archive_id."' AND status='0' ORDER BY archiveitem_id ASC LIMIT $perpage");
	while($row=$db->fetch_array($result)) $files[]=$row;
	
	if(count($files)>0)
	{
		$addeditems="";
		$skippeditems="";
		
		// now go through these files
		for($i=0;$i<count($files);$i++)
		{
			// type: file
			if($files[$i]['type']=="file")
			{
				$dir1 = dirname($files[$i]['filename']);
				if($dir1==".") $dir1="";
				$dir1 = trim($dir."/".$dir1);
				if($dir1=="/") $dir1="";
				if(substr($dir1,-1,1)=="/") $dir1=substr($dir1,0,strlen($dir1)-1);
				
				$filename1 = get_filename(basename($files[$i]['filename']));
				$extension1 = get_fileextension(basename($files[$i]['filename']));
	
				// get checksum of the file and the last version
				$checksum=checksum_file($files[$i]['tmpfile']);
				$r_preversion = $db->query_first("SELECT v.version_id,v.checksum FROM ".$db->getPrefix()."versions v LEFT JOIN ".$db->getPrefix()."files f ON f.file_id=v.file_id WHERE v.project_id='$project_id' AND f.dir='".addslashes($dir1)."' AND f.filename='".addslashes($filename1)."' AND f.extension='".addslashes($extension1)."' AND v.deletedate='0' ORDER BY v.createdate DESC LIMIT 1",MYSQL_ASSOC);
				// compare these checksums
				// if the checksums equal, stop the update of this file (skip)
				
				// checksums do not equal, continue normally
				if(!($r_preversion['version_id'] && $r_preversion['checksum']==$checksum))
				{
					list($version_id,$file_id) = addfile($project_id,$filename1,$extension1,$dir1,"",$log,$createdate,$checksum,$files[$i]['size']);
					@copy($files[$i]['tmpfile'],"./files/".$version_id.ifelse($extension1,".".$extension1));
					@chmod("./files/".$version_id.ifelse($extension1,".".$extension1),0777);
					$addeditems.=",".$files[$i]['archiveitem_id'];
				}
				
				// checksums equal, skip this file
				else $skippeditems.=",".$files[$i]['archiveitem_id'];
				@unlink($files[$i]['tmpfile']);
			}
			
			
			// type: folder
			elseif($files[$i]['type']=="folder")
			{
				$dir1 = $files[$i]['filename'];
				if(substr($dir1,-1,1)=="/") $dir1=substr($dir1,0,strlen($dir1)-1);
				if($dir1==".") $dir1="";
				$dir1 = trim($dir."/".$dir1);
				
				// insert this folder into databse
				if($dir1!="/")
				{
					$db->query("INSERT IGNORE INTO ".$db->getPrefix()."files (project_id,dir,createdate,isfile) VALUES ('$project_id','$dir1','$createdate','0')");
					$addeditems.=",".$files[$i]['archiveitem_id'];
				}
				else $skippeditems.=",".$files[$i]['archiveitem_id'];
			}
		}
		
		// mark done items and redirect to the next loop
		if($addeditems) $db->query("UPDATE ".$db->getPrefix()."archiveitems SET status='1' WHERE archiveitem_id IN ('".str_replace(",","','",substr($addeditems,1))."')");
		if($skippeditems) $db->query("UPDATE ".$db->getPrefix()."archiveitems SET status='2' WHERE archiveitem_id IN ('".str_replace(",","','",substr($skippeditems,1))."')");
		unlock_project($project_id);
		header("Location: update.php?type=archive_addfiles&archive_id=$archive_id&sid=$sidviaget");
		exit;
	}


	// all files have been added
	// - now update project (date of lastchange etc. etc.)
	// - send notification emails
	// - delete temporary files
	else
	{
		@unlink($archive_info['filename']);
		$result = $db->query("SELECT filename,type FROM ".$db->getPrefix()."archiveitems WHERE archive_id='$archive_id' AND status='1'");
		while($row=$db->fetch_array($result,MYSQL_ASSOC)) $notify_updates[] = $dir."/".$row['filename'];
		$db->query("DELETE FROM ".$db->getPrefix()."archives WHERE archive_id='".$archive_id."'");
		$db->query("DELETE FROM ".$db->getPrefix()."archiveitems WHERE archive_id='".$archive_id."'");
		// send notification emails
		notify($project_id,$user_info['user_id'],$user_info['displayname'],$user_info['email'],time(),"newfile",$notify_updates, $log);
		
		update_project($project_id,$user_info['user_id'],$createdate);
		unlock_project($project_id);
		
		// print out "done message"
		//eval("\$tpl->out(\"".$tpl->get("done")."\");");
		show_msg("done");
	}
}
?>