<?php
require("global.php");

eval("\$tpls['header'] = \"".$tpl->get("header")."\";");
eval("\$tpls['footer'] = \"".$tpl->get("footer")."\";");



/** sort */
if(isSet($_REQUEST['sort']))
{
	if(!isSet($_REQUEST['sortby'])) $_REQUEST['sortby']="filename";
	if(!isSet($_REQUEST['sortorder'])) $_REQUEST['sortorder']="ASC";
	
	header("Location: browse.php?project_id=$project_id&dir=$dir&sortby=$_REQUEST[sortby]&sortorder=$_REQUEST[sortorder]&sid=$sidviaget");
	exit;
}












/** delete multiple files */
elseif(isSet($_REQUEST['delete']))
{
	// initiate parameters
	if(isset($_REQUEST['sure'])) $sure = $_REQUEST['sure'];
	else $sure = "";
	if(isset($_REQUEST['folders'])) $folders = $_REQUEST['folders'];
	else $folders = "";
	if(isset($_REQUEST['files'])) $files = $_REQUEST['files'];
	else $files = "";

	if(!$project_id || (!is_array($folders) && !is_array($files)))
	{
		show_error("input_error");
	}
	
	// ask user if he/she is sure to delete xyz
	if(!$sure)
	{
		$target="action.php";
		$deletevalues = "";
		// return submitted values for next form
		if(is_array($folders))
		{
			foreach($folders as $value)
			{
				$deletevalues .= "<input type=\"hidden\" name=\"folders[]\" value=\"$value\">\n";
			}
		}
		if(is_array($files))
		{
			foreach($files as $value)
			{
				$deletevalues .= "<input type=\"hidden\" name=\"files[]\" value=\"$value\">\n";
			}
		}
		$deleteversion="";
		$backups="";
		eval("\$tpl->out(\"".$tpl->get("delete_sure")."\");");
	}

	// delete
	else
	{
		lock_project($project_id);
		$deletedate = time();
		
		// delete folder
		if(is_array($folders))
		{
			tmpdeletefolder($project_id,$folders,$files,$deletedate);
		}
		
		// delete files
		if(is_array($files))
		{
			tmpdeletefiles($project_id,$files,$deletedate);
		}
		
		// send notification emails
		$updates=array();
		if(is_array($folders)) $updates=array_merge($updates,$folders);
		if(is_array($files))
		{
			$result = $db->query("SELECT dir,filename,extension FROM ".$db->getPrefix()."files WHERE project_id='$project_id' AND file_id IN('".implode("','",$files)."')");
			while($row=$db->fetch_array($result,MYSQL_ASSOC))	$updates[]=$row['dir']."/".get_shownfilename($row['filename'],$row['extension']);
		}
		if(count($updates)>0) notify($project_id,$user_info['user_id'],$user_info['displayname'],$user_info['email'],time(),"delete",$updates);
		
		
		// update project
		$lastchange = $db->query_first("SELECT createdate as lastchange,autor_id as lasteditor FROM ".$db->getPrefix()."versions WHERE project_id=$project_id AND deletedate=0 ORDER BY createdate DESC LIMIT 1",MYSQL_ASSOC);
		update_project($project_id,$lastchange['lasteditor'],$lastchange['lastchange']);
		unlock_project($project_id);
		//eval("\$tpl->out(\"".$tpl->get("done")."\");");
		show_msg("done", -2);
	}
}




















/** download */
elseif(isSet($_REQUEST['download']))
{
	if(isset($_REQUEST['folders'])) $folders = $_REQUEST['folders'];
	else $folders = "";
	if(isset($_REQUEST['files'])) $files = $_REQUEST['files'];
	else $files = "";
	
	if(isSet($_REQUEST['compression_level'])) $compression_level=$_REQUEST['compression_level'];
	else $compression_level=-1;
	if(!extension_loaded("zlib")) $compression_level=-1;
	if(isSet($_REQUEST['archive_type'])) $archive_type=$_REQUEST['archive_type'];
	else $archive_type="zip";
	if($archive_type!="zip" && $archive_type!="tgz") $archive_type="zip";
	
	if(!$project_id || (!is_array($folders) && !is_array($files)))
	{
		show_error("input_error");
	}
	
	
	if($archive_type=="zip")
	{
		include("class.zip.php");
		$archive = new writezip("null", $compression_level, 0);
		$extension="zip";
	}
	elseif($archive_type=="tgz")
	{
		$extension=ifelse($compression_level==-1,"tar","tar.gz");
		$tmpname="./temp/".md5(uniqid(rand()."_tar")).".".$extension;
		if(file_exists($tmpname)) while(file_exists($tmpname)) $tmpname="./temp/".md5(uniqid(rand()."_tar")).".".$extension;
		include("class.tar.php");
		$archive = new writetar($tmpname, $compression_level);
		$archive->open();
	}



	$timestamp=time();
	
	if(!is_array($folders)) $folders=array();
	if(!is_array($files)) $files=array();
	if(count($folders))
	{
		$where_str="";
		foreach($folders as $folder)
		{
			if($where_str) $where_str.=" OR dir LIKE '".addslashes($folder)."%'";
			else $where_str.="dir LIKE '".addslashes($folder)."%'";
		}
		$sub=$db->query("SELECT file_id,dir,isfile FROM ".$db->getPrefix()."files WHERE project_id='$project_id' AND (deletedate=0 OR deletedate) AND ($where_str)");
		while($row = $db->fetch_array($sub,MYSQL_ASSOC))
		{
			if($row['isfile'])
			{
				$files[] = $row['file_id'];
			}
			else
			{
				$folders[] = $row['dir'];
			}
		}
	}


	// add folders
	if(count($folders))
	{
		$result = $db->query("SELECT f.dir,f.createdate,f.isfile FROM ".$db->getPrefix()."files f WHERE project_id='$project_id' AND f.isfile='0' AND f.deletedate='0' AND f.dir IN('".implode("','",$folders)."')");
		while($row=$db->fetch_array($result)) $archive->add_dir(substr(ifelse(substr($row['dir'],0,strlen($dir))==$dir,substr($row['dir'],strlen($dir)),$row['dir']),1)."/",$row['createdate']);
	}
	
	
	// add files
	if(count($files)==0) show_error("input_error");
	
	$result = $db->query("SELECT f.dir,f.filename,f.extension,v.version_id,v.createdate,f.isfile 
	FROM ".$db->getPrefix()."files f LEFT JOIN ".$db->getPrefix()."versions v ON v.version_id=f.version_id 
	WHERE f.project_id='$project_id' AND f.isfile='1' AND f.deletedate='0' AND f.file_id IN('".implode("','",$files)."')");
	while($file=$db->fetch_array($result,MYSQL_ASSOC))
	{
		$path="";
		if($file['dir'])
		{
			if($dir) $path=substr(ifelse(substr($file['dir'],0,strlen($dir))==$dir, substr($file['dir'],strlen($dir)), $file['dir']),1)."/";
			else $path=substr($file['dir'],1)."/";
		}
		if($path=="/") $path="";

		$archive->add_file("./files/".$file['version_id'].ifelse($file['extension'],".".$file['extension']), $path.$file['filename'].ifelse($file['extension'],".".$file['extension']), $file['createdate']);
	}

	
	header("Content-type: application/octet-stream\nContent-Disposition: attachment; filename = \""."webPM_downloaded_files_".preg_replace("/[<>\|\?\.\*\/\\\]+/","_",$project_info['project_name'])."_".date("Y-m-d H-i",time()).".".$extension."\"\nPragma: no-cache\nExpires: 0\n");
	if($archive_type=="zip") echo $archive->create();
	elseif($archive_type=="tgz")
	{
		$archive->close();
		readfile($tmpname);
		unlink($tmpname);
	}

}


?>