<?php
require("global.php");

// set a time limit because the comparision of two huge 
// files may last longer than normal operations
@set_time_limit(40);


eval("\$tpls['header'] = \"".$tpl->get("header")."\";");
eval("\$tpls['footer'] = \"".$tpl->get("footer")."\";");


// initiate parameters
$version1 = intval($_REQUEST['version1']);
$version2 = intval($_REQUEST['version2']);





// read in information about the file
$file_info = $db->query_first("SELECT filename,extension FROM ".$db->getPrefix()."files WHERE file_id=$file_id");
$file_info['shownfilename'] = htmlconverter(get_shownfilename($file_info['filename'],$file_info['extension']));

// read in information about the two versions
$result = $db->query("SELECT * FROM ".$db->getPrefix()."versions WHERE version_id IN('$version1','$version2')");
$version_info1 = $db->fetch_array($result,MYSQL_ASSOC);
$version_info2 = $db->fetch_array($result,MYSQL_ASSOC);

// no binary file => compare the two versions
$binarytypes=explode(",",$options['binarytypes']);
$imagetypes=explode(",",$options['imagetypes']);
if(!in_array(strtolower($file_info['extension']),$binarytypes) && !in_array(strtolower($file_info['extension']),$imagetypes))
{
	exec("diff -v",$diffversion);
	$diffversion=implode(" ",$diffversion);
	if(stristr($diffversion, "Version")) $usediff=1;
	else $usediff=0;
	
	// call `diff' via exec() and fetch the 
	// result (unified diff with 3 context lines)	
	if($usediff==1)
	{
		// we need to provide the full path to the two versions
		if($config['basedir']==".")
		{
			if(isset($_SERVER['PATH_TRANSLATED']))
			{
				$basedir = dirname($_SERVER['PATH_TRANSLATED']);
				chdir($basedir);
			}
		}
		exec("diff -BbU 10 $config[basedir]/files/$version1".ifelse($file_info['extension'],".".$file_info['extension'])." $config[basedir]/files/$version2".ifelse($file_info['extension'],".".$file_info['extension']), $patch);
		$patch=array_map("chop",$patch);
		if(count($patch)>2) $patch=trim(implode("\n",$patch));
		else $patch="";
		
		// diff failed (safe mode? wrong path?)
		// use php implementation
		if(!$patch) $usediff=0;
	}
	
	
	
	// use php implementation to generate a diff
	if($usediff==0)
	{
		// read in the two versions and leave out blank lines
		$a=array();
		foreach(file("./files/$version1".ifelse($file_info['extension'],".".$file_info['extension'])) as $line)
		{
			$line=chop($line);
			if(trim($line))	$a[]=$line;
		}
		
		$b=array();
		foreach(file("./files/$version2".ifelse($file_info['extension'],".".$file_info['extension'])) as $line)
		{
			$line=chop($line);
			if(trim($line))	$b[]=$line;
		}
		
		
		include("class.diff.php");
		include("class.formatdiff.php");
		
		// compute diff
		$diff = new diff($a,$b);
		$lcs = $diff->getdiff();
		
		// generate a unix-`diff' compatible diff/patch
		$formatdiff = new formatdiff($a, $b, $lcs, "u", 3);
		$patch = $formatdiff->output();
	}
	

	include("class.printdiff.php");
	
	// colorize changes
	$printdiff = new printdiff($patch);
	$printdiff->blankcolor = $options['comparecolors_blankcolor'];
	$printdiff->oldcolor = $options['comparecolors_oldcolor'];
	$printdiff->newcolor = $options['comparecolors_newcolor'];
	$printdiff->deletecolor = $options['comparecolors_deletecolor'];
	$compare->insertcolor = $options['comparecolors_insertcolor'];
	$patch = $printdiff->output($usediff);

	
	eval("\$tpl->out(\"".$tpl->get("compare")."\");");
}
else // binary file => no comparision 
{
	if(!isset($rows)) $rows = "";
	eval("\$tpl->out(\"".$tpl->get("compare_binary")."\");");
}
?>