<?php
require("global.php");

eval("\$tpls['header'] = \"".$tpl->get("header")."\";");
eval("\$tpls['footer'] = \"".$tpl->get("footer")."\";");


if(!$project_id || !$file_id || !$version_id) show_error("input_error");
// user has no writeaccess
if(!$writeaccess[$project_id])
{
	show_error("access_denied");
}


// select file informations
$file_info = $db->query_first("SELECT f.file_id,f.project_id,f.filename,f.extension,f.dir 
FROM ".$db->getPrefix()."files f 
WHERE f.file_id=$file_id AND f.project_id=$project_id AND f.deletedate=0");
// select informations about this version
$version_info = $db->query_first("SELECT v.*
FROM ".$db->getPrefix()."versions v 
WHERE v.version_id=$version_id AND v.project_id=$project_id AND v.file_id=$file_id AND v.deletedate=0");

if(!$version_info['version_id'] || !$file_info['file_id']) show_error("input_error");

$binarytypes=explode(",",$options['binarytypes']);
$imagetypes=explode(",",$options['imagetypes']);
if(in_array(strtolower($file_info['extension']),$binarytypes) || in_array(strtolower($file_info['extension']),$imagetypes)) show_error("access_denied");

if(!isset($_POST['send']))
{
	$filename=$file_info['dir']."/".get_shownfilename($file_info['filename'],$file_info['extension']);
	$content=implode("",file("./files/".get_shownfilename($version_info['version_id'],$file_info['extension'])));
	$content=htmlconverter($content);

	eval("\$tpl->out(\"".$tpl->get("editor")."\");");
}

else
{
	if(isset($_POST['log'])) $log=$_POST['log'];
	else $log="";
	if(isset($_POST['content'])) $content=preg_replace("!(\r\n)|(\r)!","\n",$_POST['content']);
	else $content="";
	
	// no log entry given
	if(!$log) show_error("input_error");
	
	// lock project
	$createdate=time();
	lock_project($project_id);

	// get checksum of the file and of the last version
	$checksum=calc_checksum($content);
	$r_preversion = $db->query_first("SELECT * FROM ".$db->getPrefix()."versions WHERE project_id='$project_id' AND file_id='$file_id' AND deletedate='0' AND createdate<='$createdate' ORDER BY createdate DESC LIMIT 1",MYSQL_ASSOC);
	
	// compare checksums
	if(!$r_preversion['version_id'] || $r_preversion['checksum']!=$checksum)
	{
		// add version
		list($version_id,$file_id) = addfile($project_id,$file_info['filename'],$file_info['extension'],$file_info['dir'],"",$log,$createdate,$checksum,strlen($content));
		$fh=@fopen("./files/".$version_id.ifelse($file_info['extension'],".".$file_info['extension']),"w");
		@fwrite($fh,$content);
		@fclose($fh);
		@chmod("./files/".$version_id.ifelse($file_info['extension'],".".$file_info['extension']),0777);

		// update date of lastchange etc. etc.
		update_project($project_id,$user_info['user_id'],$createdate);
		
		// send email notifications
		notify($project_id,$user_info['user_id'],$user_info['displayname'],$user_info['email'],time(),"newfile",array($file_info['dir']."/".get_shownfilename($file_info['filename'],$file_info['extension'])), $log);
	}

	// unlock the project
	unlock_project($project_id);
	
	// print "done message"
	show_msg("done",-2);
}
?>