<?php
require("global.php");
eval("\$tpls['header'] = \"".$tpl->get("header")."\";");
eval("\$tpls['footer'] = \"".$tpl->get("footer")."\";");

if(isSet($_REQUEST['action'])) $action = ($_REQUEST['action']);
else $action = "";
if(isSet($_REQUEST['notice_id'])) $notice_id = intval($_REQUEST['notice_id']);
else $notice_id = 0;
if(isSet($_REQUEST['noticethread_id'])) $noticethread_id = intval($_REQUEST['noticethread_id']);
else $noticethread_id = 0;

$project_info['project_name']=htmlconverter($project_info['project_name']);


/** no project => input error */
if(!$project_id)
{
	show_error("input_error");
}




/** overview of notice threads of a project */
if($project_id && !$noticethread_id && !$action)
{
	$tpls['notices_bit']="";
	$tpls['writenoticeform']="";
	
	$result = $db->query("SELECT nt.*,n.*, u.* FROM ".$db->getPrefix()."noticethreads nt 
	LEFT JOIN ".$db->getPrefix()."notices n ON n.notice_id=nt.first_notice_id 
	LEFT JOIN ".$db->getPrefix()."user u ON u.user_id=n.user_id WHERE 
	nt.project_id='$project_id' ORDER BY nt.lastchange DESC");
	
	while($notice=$db->fetch_array($result,MYSQL_ASSOC))
	{
		$notice['createdate_f'] = ifelse(date("dmY",time())==date("dmY",$notice['createdate']),"<b>Heute</b>",date("d.m.Y",$notice['createdate']))." - ".date("H:i",$notice['createdate']);
		$notice['lastchange_f'] = ifelse(date("dmY",time())==date("dmY",$notice['lastchange']),"<b>Heute</b>",date("d.m.Y",$notice['lastchange']))." - ".date("H:i",$notice['lastchange']);
		$notice['status'] = ifelse(($user_info['lastvisit']<=$notice['lastchange']),"<img src=\"images/new.gif\" border=\"0\" alt=\"new\">","<img src=\"images/old.gif\" border=\"0\" alt=\"old\">");
		$notice['notice_text'] = nl2br(htmlconverter(substr($notice['notice_text'],0,100)." ..."));
		$notice['noticethread_title'] = htmlconverter($notice['noticethread_title']);
		$notice['notice_title'] = htmlconverter($notice['notice_title']);
		$notice['displayname'] = htmlconverter($notice['displayname']);
		eval("\$tpls['notices_bit'] .= \"".$tpl->get("notices_overview_bit")."\";");
	}
	
	if($writeaccess[$project_id]==1)
	{
		eval("\$tpls['writenoticeform'] = \"".$tpl->get("notices_writenoticeform")."\";");
	}

	eval("\$tpl->out(\"".$tpl->get("notices_overview")."\");");
}


/** view a notice thread */
elseif($project_id && $noticethread_id && !$action)
{
	$noticethread_info=$db->query_first("SELECT * FROM ".$db->getPrefix()."noticethreads WHERE noticethread_id='$noticethread_id'", MYSQL_ASSOC);
	if(!$noticethread_info['noticethread_id'])
	{
		show_error("input_error");
	}
	else $project_id = $noticethread_info['project_id'];
	if(!$readaccess[$project_id])
	{
		show_error("access_denied");
	}
	
	
	$noticethread_info['noticethread_title'] = htmlconverter($noticethread_info['noticethread_title']);
	$tpls['notices_bit']="";
	$tpls['writenoticeform']="";
	
	$result = $db->query("SELECT n.*, u.* FROM ".$db->getPrefix()."notices n 
	LEFT JOIN ".$db->getPrefix()."user u ON u.user_id=n.user_id WHERE n.noticethread_id='$noticethread_id' 
	ORDER BY n.createdate ASC");
	while($notice = $db->fetch_array($result,MYSQL_ASSOC))
	{
		$notice['createdate_f'] = ifelse(date("dmY",time())==date("dmY",$notice['createdate']),"<b>Heute</b>",date("d.m.Y",$notice['createdate']))." - ".date("H:i",$notice['createdate']);
		if(!$notice['notice_title']) $notice['notice_title'] = "re: ".$noticethread_info['noticethread_title'];
		$notice['notice_text'] = nl2br(htmlconverter($notice['notice_text']));
		$notice['notice_title'] = htmlconverter($notice['notice_title']);
		$notice['displayname'] = htmlconverter($notice['displayname']);
		eval("\$tpls['notices_bit'] .= \"".$tpl->get("notices_noticethread_bit")."\";");
	}
	
	if($writeaccess[$project_id]==1)
	{
		eval("\$tpls['writenoticeform'] = \"".$tpl->get("notices_writenoticeform")."\";");
	}
	eval("\$tpl->out(\"".$tpl->get("notices_noticethread")."\");");
}




/** write notice (new or in an existing notice thread) */
elseif($project_id && $action=="writenotice")
{
	if(isSet($_REQUEST['notice_title'])) $notice_title = $_REQUEST['notice_title'];
	else $notice_title="";
	if(isSet($_REQUEST['notice_text'])) $notice_text = $_REQUEST['notice_text'];
	else $notice_text="";
	
	if(!trim($notice_text) || (!trim($notice_title) && !$noticethread_id))
	{
		show_error("input_error");
	}
	if($noticethread_id)
	{
		$noticethread_info = $db->query_first("SELECT * FROM ".$db->getPrefix()."noticethreads WHERE noticethread_id='$noticethread_id'");
		if(!$noticethread_info['noticethread_id']) show_error("input_error");
		if(!$writeaccess[$project_id]) show_error("access_denied");
		$project_id=$noticethread_info['project_id'];
		$noticethread_id=$noticethread_info['noticethread_id'];
	}
	
	$createdate=time();
	$db->query("INSERT INTO ".$db->getPrefix()."notices (noticethread_id,user_id,createdate,notice_title,notice_text) VALUES ('$noticethread_id', '$user_info[user_id]', '$createdate', '".addslashes($notice_title)."', '".addslashes($notice_text)."')");
	$notice_id = $db->insert_id();
	
	if(!$noticethread_id)
	{
		$db->query("INSERT INTO ".$db->getPrefix()."noticethreads (project_id, first_notice_id, lastchange, noticethread_title) VALUES ('$project_id', '$notice_id', '$createdate', '".addslashes($notice_title)."')");
		$noticethread_id = $db->insert_id();
		$db->query("UPDATE ".$db->getPrefix()."notices SET noticethread_id='$noticethread_id' WHERE notice_id='$notice_id'");
	}
	else
	{
		$db->query("UPDATE ".$db->getPrefix()."noticethreads SET lastchange='$createdate' WHERE noticethread_id='$noticethread_id'");
	}
	
	if($notice_title) $notify_title=$notice_title;
	elseif(isset($noticethread_info['noticethread_title'])) $notify_title="re: ".$noticethread_info['noticethread_title'];
	else $notify_title="";
	notify($project_id,$user_info['user_id'],$user_info['displayname'],$user_info['email'],time(),"newnotice",array($notify_title, $notice_text));
	
	header("Location: notices.php?project_id=$project_id&noticethread_id=$noticethread_id&sid=$sidviaget");
	exit;
}




/** edit notice */
elseif($notice_id && $action=="editnotice")
{
	$notice_info = $db->query_first("SELECT n.*,nt.* FROM ".$db->getPrefix()."notices n LEFT JOIN ".$db->getPrefix()."noticethreads nt ON nt.noticethread_id=n.noticethread_id WHERE n.notice_id='$notice_id'", MYSQL_ASSOC);
	if(!$notice_info['notice_id']) show_error("input_error");
	else
	{
		$project_id=$notice_info['project_id'];
		$noticethread_id=$notice_info['noticethread_id'];
	}
	if(!$writeaccess[$project_id] || !$readaccess[$project_id] || $notice_info['user_id']!=$user_info['user_id']) show_error("access_denied");
	
	if(isSet($_POST['send']) && $_POST['send']=="send")
	{
		/** delete Notice */
		if(isSet($_POST['deletenotice']) && $_POST['deletenotice']==1)
		{
			$db->query("DELETE FROM ".$db->getPrefix()."notices WHERE notice_id='$notice_id'");
			list($count)=$db->query_first("SELECT COUNT(*) as noticecount FROM ".$db->getPrefix()."notices WHERE noticethread_id='$noticethread_id'", MYSQL_NUM);
			if($count==0)
			{
				$db->query("DELETE FROM ".$db->getPrefix()."noticethreads WHERE noticethread_id='$noticethread_id'");
			}
			else
			{
				if($notice_info['lastchange']==$notice_info['createdate'])
				{
					list($lastchange)=$db->query_first("SELECT MAX(createdate) as lastchange FROM ".$db->getPrefix()."notices WHERE noticethread_id='$noticethread_id'", MYSQL_NUM);
					$db->query("UPDATE ".$db->getPrefix()."noticethreads SET lastchange='$lastchange' WHERE noticethread_id='$noticethread_id'");
				}
				if($notice_info['notice_id']==$notice_info['first_notice_id'])
				{
					list($first_notice_id)=$db->query_first("SELECT MIN(notice_id) as first_notice_id FROM ".$db->getPrefix()."notices WHERE noticethread_id='$noticethread_id'", MYSQL_NUM);
					$db->query("UPDATE ".$db->getPrefix()."noticethreads SET first_notice_id='$first_notice_id' WHERE noticethread_id='$noticethread_id'");
				}
			}
			header("Location: notices.php?project_id=$project_id&sid=$sidviaget");
			exit;
		}
		/** save notice */
		else
		{
			if(isSet($_REQUEST['notice_title'])) $notice_title = addslashes($_REQUEST['notice_title']);
			else $notice_title="";
			if(isSet($_REQUEST['notice_text'])) $notice_text = addslashes($_REQUEST['notice_text']);
			else $notice_text="";
			
			if(!trim($notice_text)) show_error("input_error");
			$db->query("UPDATE ".$db->getPrefix()."notices SET notice_title='$notice_title', notice_text='$notice_text' WHERE notice_id='$notice_id'");
			header("Location: notices.php?project_id=$project_id&noticethread_id=$noticethread_id&sid=$sidviaget");
			exit;
		}
	}
	
	/** show form */
	else
	{
		$notice_info['notice_text']=htmlconverter($notice_info['notice_text']);
		$notice_info['notice_title']=htmlconverter($notice_info['notice_title']);
		eval("\$tpl->out(\"".$tpl->get("notices_editnotice")."\");");
	}
	
}

?>